local function doFileChanges(self,data,fileChangesTable)
	local fChanges = fileChangesTable[data.file]
	if fChanges then
		for _, obj in pairs(data.res) do
			if type(obj) == "table" then
				if fChanges.all then fChanges.all(obj) end
				local oChanges = fChanges[obj.define_as] or fChanges[obj.name]
				if oChanges then
					if oChanges.mut then oChanges.mut(obj) end
					if oChanges.set then
						for key,val in pairs(oChanges.set) do
							obj[key] = val
						end
					end
					if oChanges.remove then
						for _,key in pairs(oChanges.remove) do
							obj[key] = nil
						end
					end
				end
			end
		end
	end
end
local allMoveNoSplit = {all = function(obj)
	if obj.never_move then obj.never_move = nil end
	if obj.clone_on_hit then obj.clone_on_hit = nil end
end}
local fileChangesTable = {
	["/data/general/npcs/horror_aquatic.lua"] = allMoveNoSplit,
	["/data/general/npcs/jelly.lua"] = allMoveNoSplit,
	["/data/general/npcs/molds.lua"] = allMoveNoSplit,
	["/data/general/npcs/ooze.lua"] = allMoveNoSplit,
	["/data/general/npcs/plant.lua"] = allMoveNoSplit,
}

class:bindHook("Entity:loadList", function(self, data)
	doFileChanges(self,data,fileChangesTable)
end)
