long_name = "QuickTome: Improved Recall"
short_name = "qt-improved-recall"
for_module = "tome"
version = {1,4,8}
addon_version = {1,0,14}
weight = 216890 -- All QuickTome addons have weight between 216000 and 216999.
author = { "minmay", "a@cowmuffins.net" }
homepage = "http://www.cowmuffins.net/"
description = [[This addon is part of the QuickTome addon set.

This addon allows the Rod of Recall to teleport to almost any zone that you can access, removing the need to pass through the worldmap. You still must wait 40 turns and be able to enter the worldmap (no detrimental effects etc).
You can also teleport in the same way by using a staircase (or portal, etc) that leads to the worldmap.
You can teleport to the lumberjack village, Thieves' Tunnels, and the Crypt of Kryl-Feijan, once you meet their level requirements. Thieves' Tunnels and Crypt of Kryl-Feijan no longer appear as worldmap encounters, but you still only get one chance at them: after teleporting to Thieves' Tunnels or Crypt of Kryl-Feijan once, you can't go back a second time.
This addon also removes the maximum level restriction on the "Storming the City" quest.
This addon detects the presence of QuickTome: Zone Overhaul and will adjust the zones it can teleport to accordingly. It also does not interfere with the Ashes of Urh'Rok change to recall.
This addon works with the Orcs: Embers of Rage campaign.
However, it cannot automatically detect zones, so if you are using third-party addons that add/remove/move zones, they won't be compatible.

===== Compatibility =====
This addon is guaranteed to be compatible with the rest of the QuickTome set. If it isn't, that is a bug and should be reported.

This addon OVERLOADS these files, and will not be compatible with other addons that touch them:
/data/quests/lightning-overload.lua
/data/quests/lumberjack-cursed.lua

This addon assumes these files do not already exist:
/data/chats/qt-recall.lua

This addon overwrites the use_power field on the Rod of Recall.

Weight: 216890

===== Known Issues =====
- Due to the way certain hacks in vanilla interact with my own hacks, entering the Sher-Tul Fortress and Ruined Halfling Complex for the first time, or entering Unremarkable Cave, can result in you appearing directly outside those zones the next time you visit the worldmap, even if you teleport somewhere else first.
- Sometimes your character has ways to reach a zone but will still not be allowed to teleport to it. Zigur is the main offender.
- In Orcs: Embers of Rage, you have to go to the world map to actually complete the Dominion Port quest, and trying to teleport out of the Kruk Pride invasion tunnel will always place you in Kruk Pride.

===== Changelog =====

= 1.0.0 =
- Initial release

= 1.0.1 =
- Updated for qt-zone-overhaul 1.0.4
- Added compatibility section (really wanted to get 1.0.0 out as soon as possible!)

= 1.0.2 =
- Fixed serialization bug that could leave player with nil wilderness position (requiring save editing to continue) if they teleported with the rod of recall, then saved and reloaded the game, then visited the worldmap without teleporting anywhere else.

= 1.0.3 =
- Updated for qt-zone-overhaul 1.0.11

= 1.0.4 =
- Fix typo that caused Briagh's Lair to be accessible when it shouldn't

= 1.0.5 =
- Updated for qt-zone-overhaul 1.0.13

= 1.0.6 =
- Allowed teleporting via zone exits, not just the Rod
- Removed the Thieves' Tunnels and Crypt of Kryl-Feijan as worldmap encounters, since you would always prefer to teleport to them instead anyway
- Added Shatur and Elvala to the teleport list
- Made wilderness position adjustment a little safer, and clarified a comment about it
- Don't allow teleporting to Tempest Peak without meeting the prerequisites

= 1.0.7 =
- Don't try to teleport when exiting damp/intimidating caves, Rat Lich crypt, etc. via the stairs

= 1.0.8 =
- Fix regression in tier 1 zone teleports for non-Zone Overhaul games
- Fix "Never Look Back And There Again" achievement being awarded when it shouldn't
- Fix teleport conditions to give the proper results for Sunwall characters that haven't gone west
- Updated for future Zone Overhaul version

= 1.0.9 =
- Fix Murgol Lair exit position

= 1.0.10 =
- Greatly improve worldmap position handling: zone entrance positions are now auto-detected instead of enumerated, multiple onLevelLoads are no longer added
- Wilderness position is now set for randomly placed zones

= 1.0.11 =
- Updated for ToME4 version 1.4.8
- Added Orcs: Embers of Rage support
- Cleaned up some dead code and clarified a comment

= 1.0.12 =
- Updated for qt-zone-overhaul version 1.0.18
- Capitalization fix (cosmetic only): Rak'Shor Pride -> Rak'shor Pride

= 1.0.13 =
- Updated for qt-zone-overhaul version 1.0.22

= 1.0.14 =
- Updated for qt-zone-overhaul version 1.0.27]]
tags = { 'quicktome', 'convenience' }
data = true
hooks = true
overload = true
