long_name = "QuickTome: Item Tweaks"
short_name = "qt-item-tweaks"
for_module = "tome"
version = {1,4,8}
addon_version = {1,0,5}
weight = 216968 -- All QuickTome addons have weight between 216000 and 216999.
author = { "minmay", "a@cowmuffins.net" }
homepage = "http://www.cowmuffins.net/"
description = [[This addon is part of the QuickTome addon set.

This addon changes some items to better fit with QuickTome's design goals. This is primarily a balance addon, but a few items are also changed for being annoying or encouraging grinding.

The following items have been nerfed for being overcentralizing:
- Eden's Guile no longer generates.
- Wanderer's Rest no longer has Telekinetic Leap.
- Threads of Fate no longer has See the Threads.
- Lightning Catcher no longer gives its special timed effect. Instead, it gives the equivalent of 6 stacks of it while worn.
- Wrap of Stone no longer has Stone Wall.

The following items have been buffed for being garbage:
- Cuirass of the Thronesmen now gives 30 defense (up from 20), 42 armor (up from 32), +20% armor hardiness (up from 10%), 60% stun immunity (up from 40%).
- Crown of the Elements now gives +15% damage (up from +8%), 25+25+25+25 melee damage (up from 10+10+10+10).

Other item tweaks:
- Goedalath Rock no longer has "when carried" effects. These were annoying and totally meaningless since you could just stash the item.
- Celia's Still Beating Heart can no longer be used to get souls.
- The Black Ring's talent on spell is now Invoke Darkness in place of Darkfire.
- Ureslak's Molted Scales no longer generates (ridiculously bad item, and had nothing interesting about it).
- Dragonskull Helm no longer generates. Dragon-Helm of Kroltar is now worn by Massok in its place, and has the Dragonskull Helm's save bonuses (+12) even when not in a set. The completed set is the same as before and has not been buffed.
- Ak'Gishil and The Bladed Rift can no longer be used to farm artifact longswords. However, Ak'Gishil will always drop the Blade of Distorted Time.

===== Compatibility =====
This addon is guaranteed to be compatible with the rest of the QuickTome set. If it isn't, that is a bug and should be reported.

All this addon does is change some item properties with the Entity:loadList hook. Unless other addons are modifying these items too, there should be no compatibility problems.

Weight: 216968

===== Changelog =====

= 1.0.5 =
- Fixed fatal bug when loading entity lists containing unexpected types.

= 1.0.4 =
- Removed spurious 'data' folder that somehow got copied from Sight Overhaul. (It was never loaded, so this literally changes nothing except the filesize)

= 1.0.3 =
- Dragonskull Helm no longer generates. Dragon-Helm of Kroltar is now worn by Massok in its place, and has the Dragonskull Helm's save bonuses (+12) even when not in a set. The completed set is the same as before and has not been buffed.
- Do not allow farming artifact longswords with The Bladed Rift or Ak'Gishil. Ak'Gishil is now guaranteed to drop the Blade of Distorted Time if it hasn't been generated already.

= 1.0.2 =
- Ureslak's Molted Scales no longer generates (ridiculously bad item, and had nothing interesting about it).
- Cuirass of the Thronesmen now gives 36 defense (up from 20), 48 armor (up from 32), +20% armor hardiness (up from 10%), 60% stun immunity (up from 40%).
- Crown of the Elements now gives +15% damage (up from +8%), 25+25+25+25 melee damage (up from 10+10+10+10).
- Wrap of Stone no longer has Stone Wall.

= 1.0.1 =
- Change The Black Ring's talent on spell from Darkfire to Invoke Darkness, removing the friendly fire issues.

= 1.0.0 =
- Initial release]]
tags = { 'quicktome', 'balance' }
hooks = true
