local ActorTalents = require("engine.interface.ActorTalents")
local function doTalentChanges(changes)
	for talentId,changes in pairs(changes) do
		local talent = Talents.talents_def[talentId]
		if talent then -- Ashes of Urh'Rok talents etc. might not exist
			if changes.mut then changes.mut(talent) end
			if changes.set then
				for key,val in pairs(changes.set) do
					talent[key] = val
				end
			end
			if changes.remove then
				for _,key in pairs(changes.remove) do
					talent[key] = nil
				end
			end
		end
	end
end

local function makeChanges()
local talentChangesTable = {
	["T_TWILIGHT"] = { -- The passive interferes with our new positive/negative regen (and is obsoleted by them), kill it.
		remove = {"passives"},
		set = {	info = function(self, t)
		return ([[You stand between the darkness and the light, allowing you to convert 15 positive energy into %d negative energy.
The negative energy gain will increase with your Cunning.]]):format(t.getNegativeGain(self, t), t.getRestValue(self, t))
end,
		},
	},
}
doTalentChanges(talentChangesTable)
end

makeChanges()
