class:bindHook("ToME:load", function(self, data)
	-- This is also kinda gross, but it gets the job done without introducing any compatibility issues.
	local desc = require("engine.Birther"):getBirthDescriptor("base","base")
	desc.copy.mana_regen = 0.2
	desc.copy.vim_regen = 0.2
	desc.copy.equilibrium_regen = -0.1
	desc.copy.psi_regen = 0.2
	desc.copy.positive_regen = 0.2
	desc.copy.negative_regen = 0.2
	desc.copy.can_breath = desc.copy.on_breath or {}
	desc.copy.can_breath.water = 1

	require("engine.interface.ActorTalents"):loadDefinition("/data-qt-resource-tweaks/talentChanges.lua")
end)

local function doFileChanges(self,data,fileChangesTable,allFunc)
	local fChanges = fileChangesTable[data.file]
	if fChanges or allFunc then
		for _, obj in pairs(data.res) do
			if type(obj) == "table" then
				if fChanges then
					if fChanges.all then fChanges.all(obj) end
					local oChanges = fChanges[obj.define_as] or fChanges[obj.name]
					if oChanges then
						if oChanges.mut then oChanges.mut(obj) end
						if oChanges.set then
							for key,val in pairs(oChanges.set) do
								obj[key] = val
							end
						end
						if oChanges.remove then
							for _,key in pairs(oChanges.remove) do
								obj[key] = nil
							end
						end
					end
				end
				if allFunc then
					allFunc(obj)
				end
			end
		end
	end
end
local noGeneration = {remove={"rarity"}}
local fileChangesTable = {
	["/data/general/objects/random-artifacts.lua"] = {
		["water breathing"] = noGeneration,
	},
	["/data/general/objects/egos/helm.lua"] = {
		[" of the depths"] = noGeneration,
	},
	["/data/general/objects/egos/armor.lua"] = {
		[" of the deep"] = noGeneration,
	},
	["/data/zones/temple-of-creation/objects.lua"] = {
		["ELDRITCH_PEARL"] = {mut = function(obj) if obj.wielder and obj.wielder.can_breath then obj.wielder.can_breath = nil end end},
	},
}

class:bindHook("Entity:loadList", function(self, data)
	doFileChanges(self,data,fileChangesTable)
end)
