local _M = loadPrevious(...)

local orig_restCheck = _M.restCheck

function _M:restCheck()
	local rval1,rval2 = orig_restCheck(self)
	if rval1 == false and self.resting.rested_fully then -- vanilla game thinks we rested fully...
		-- ...but we may need to let positive and negative regenerate.
		if self:getPositive() < self:getMaxPositive() and self.positive_regen > 0 then self.resting.rested_fully = false rval1 = true end
		if self:getNegative() < self:getMaxNegative() and self.negative_regen > 0 then self.resting.rested_fully = false rval1 = true end
	end

	if rval1 == true then
		-- apply resting speedup to newly regenerating resources
		for act, def in pairs(game.party.members) do if game.level:hasEntity(act) and not act.dead then
			local perc = math.min(self.resting.cnt / 10, 8)
			act:incEquilibrium(act.equilibrium_regen * perc)
			act:incVim(act.vim_regen * perc)
			act:incNegative(act.negative_regen * perc)
			act:incPositive(act.positive_regen * perc)
		end end
	end
	return rval1, rval2
end

return _M
