long_name = "QuickTome: Sight Overhaul"
short_name = "qt-sight-overhaul"
for_module = "tome"
version = {1,5,3}
addon_version = {1,0,11}
weight = 216031 -- All QuickTome addons have weight between 216000 and 216999.
author = { "minmay", "a@cowmuffins.net" }
homepage = "http://www.cowmuffins.net/"
description = [[This addon is part of the QuickTome addon set.

This addon makes major changes to ToME4's sight system:
- Sight radius is locked at 10 for all creatures, including the player.
- The lighting and infravision system is removed.
- The player-controlled creature can always see invisible and stealthed creatures, is unaffected by existing blindness status, and has full blind immunity.
- The FOV algorithm is changed slightly in order to make it symmetric: if you can see square B from square A, then you can see square A from square B.
- Darkness and Abyssal Shroud no longer make your character forget part of the map layout (Why did they ever do this in the first place???)
- Divinations, telepathy, and other forms of out-of-LOS creature detection are removed.

The addon tome-squarefov is also recommended. It is compatible with almost all other addons, including the QuickTome set.

Items, creatures, and talents are changed to accomodate the sight changes:
- Items that are based on light/sight/divination-related gimmicks do not generate randomly, and others are adjusted:
  - The following artifacts no longer generate: Burning Star, Mummified Egg-sac of Ungolë, Unflinching Eye, Merkul's Second Eye, Wintertide Phial, Choker of Dread, Withering Orbs, Helm of the Dwarven Emperors, Yaldan Baoth
  - The following randart egos no longer generate: immune blind, see invisible, infravision radius, lite radius, orc telepathy, dragon telepathy, demon telepathy
  - The following regular egos no longer generate: starlit, of vision, radiant, miner's (digger only), champion's, catburglar's, bright, of clarity, watchleader's, of sensing, of illumination, of clairvoyance, of the sentry, of the nighthunter
  - Sun infusions and vision runes no longer generate
  - Remaining artifacts and egos have light/sight/etc properties removed. EXCEPTION: Some items do not have these properties removed entirely because they are inside e.g. set complete functions; removing these is easy but would hurt compatibility with other addons, so we don't do it. The properties still have no effect.
  - Alchemist ametrine now does 10 light damage when used as a bomb, instead of lighting the area
  - Alchemist pearl now does 20 item light blind damage when used as a bomb, instead of lighting the area
  - Turquoise now has 80 max life when worn or imbued, instead of giving see invisible/stealth
  - Citrine now has 10% healing factor when worn or imbued, instead of giving light radius

- Talents and NPCs are adjusted in light of these changes:
  - Spell/Divination and Cunning/Survival are no longer available to players.
  - Track is removed entirely.
  - Escorts and Worldly Knowledge offer Spell/Conveyance talents in place of Spell/Divination, Technique/Acrobatics talents in place of Technique/Survival, and Evasion in place of Track.
  - Vimsense is now an ordinary debuff: casting it attempts to inflict Vimsense on all hostile creatures within a radius of 10, which can be saved against but can also spellshock. It no longer detects creatures, alerts them, goes through walls, or affects friendly creatures.
  - Preternatural Senses no longer offers creature detection, but to compensate for that and for stealth/invisibility detection being useless for players, it now gives you some defense and critical chance.
  - Shadow Senses no longer gives its original effect. Instead, it reduces damage from unseen attackers.
  - Thought Sense no longer offers creature detection, but its defense bonus is now passive instead of activated.
  - Earth's Eyes no longer gives its original effect. Instead, it passively improves saves. (This is crap...)
  - Precognition no longer offers creature detection, but gives some accuracy and critical strike chance.
  - Mind Link no longer offers telepathy.
  - Illuminate (the Phantasm talent) now does light damage at all levels
  - Invisibility (the Phantasm talent) is no longer used by NPCs
  - Overseer of Nations now gives confusion immunity and light and darkness resistance, instead of blindness immunity and increased sight
  - Rune: Invisibility is no longer used by NPCs (although they can still generate with them...)
  - Infusion: Sun is no longer used by NPCs (although they can still generate with them...)
  - Moment of Prescience now gives more accuracy/defense to compensate for the see invisible/stealth
  - Radiance now gives confusion immunity instead of blindness immunity
  - Illumination (the Radiance talent) now reduces defense by a greater amount to compensate for the see invisible/stealth
  - Hymn of Detection now gives spell critical chance to compensate for the see invisible/stealth
  - Armour of Shadows now gives its bonus regardless of light
  - Corrupt Light no longer uses light in any way or makes your character forget part of the map. Reaching 2 squares now gives the same bonus as reaching 1 lit square in vanilla.
  - Shadowmeld no longer requires you to be in an unlit tile.
  - Darkness (the NPC talent) is no longer used
  - Abyssal Shroud (or rather, its damage type) no longer makes your character forget part of the map layout
  - NOTE: Talents that gave see invisible/stealth still give them, since those properties are still useful for NPCs.
  - The Withering Thing now drops the Eye of the Dreaming One in place of the Withering Orbs (note: if you also have QuickTome: Zone Overhaul 1.0.4 or later, both Heart of the Gloom bosses will always drop a random artifact)
  - The Half-Finished Bone Giant now drops a random artifact in place of Wintertide Phial
  - The Master now drops a random artifact in place of the Choker of Dread

===== Compatibility =====
This addon is guaranteed to be compatible with the rest of the QuickTome set. If it isn't, that is a bug and should be reported.

This addon OVERLOADS the following files:
data/chats/worldly-knowledge.lua

This addon superloads the following functions non-destructively:
engine/Entity.lua: attr()   (Prevents player-controlled creature from being blind, even if they have a blindness status; also gives blindness immunity)
engine/Map.lua: loaded()   (Forces all squares to be lit at all times)
mod/class/interface/Combat.lua: combatArmor(), combatArmorHardiness(), combatDefenseBase(), combatMindCrit(), combatCrit() (Various talent changes)
mod/class/Actor.lua: canSeeNoCache()   (Forces stealthed/invisible creatures to always be visible to the player-controlled character)

In addition, the addon superloads and OVERWRITES the function playerFOV() in Player.lua; the original playerFOV() will never be called. This is how sight range is forced to 10 and some odd light-related behaviour is removed. Therefore, this addon almost certainly won't be compatible with any other addon that superloads this function or overloads that file.

It also utilizes these hooks:
ToME:load (to change FOV rules, talents, and Abyssal Shroud damage)
Entity:loadList (to change items and NPCs)

This addon changes the FOV algorithm, actor vision size, and FOV permissiveness; it generally won't be compatible with other addons that do the same thing. Note that tome-squarefov doesn't change any of these, so that addon IS compatible (and highly recommended!).

Weight: 216031

===== Changelog =====

= 1.0.11 =
- Update for ToME4 version 1.5.3.
- Fixed Heightened Senses description

= 1.0.10 =
- Remove Evasion from Field Control now that it's been rearranged in the main game (fixes talent requirement bug).

= 1.0.9 =
- Updated to ToME version 1.5.1.
- Don't modify Hymn of Detection anymore (since the standard version has critical multiplier now). This incidentally fixes an error that can occur in 1.5.x.

= 1.0.8 =
- Updated to ToME version 1.4.8. Note: Embers of Rage talents and items have not been changed yet.
- Reversed changelog order

= 1.0.7 =
- Violently kill creature/object/trap/map detection. Even if you somehow manage to obtain detection effects, they won't do anything.
- Spell/Divination and Cunning/Survival are no longer available to players.
- Evasion replaces Track in Field Control. Track is removed entirely.
- Vimsense is now an ordinary debuff: casting it attempts to inflict Vimsense on all hostile creatures within a radius of 10, which can be saved against but can also spellshock. It no longer detects creatures, alerts them, goes through walls, or affects friendly creatures.
- Preternatural Senses no longer offers creature detection, but to compensate for that and for stealth/invisibility detection being useless for players, it now gives you some defense and critical chance.
- Shadow Senses no longer gives its original effect. Instead, it reduces damage from unseen attackers.
- Thought Sense no longer offers creature detection, but its defense bonus is now passive instead of activated.
- Earth's Eyes no longer gives its original effect. Instead, it passively improves saves. (This is crap...)
- Precognition no longer offers creature detection, but gives some accuracy and critical strike chance.
- Mind Link no longer offers telepathy.
- Hide the Darkness talent more thoroughly.
- Escorts and Worldly Knowledge offer Spell/Conveyance talents in place of Spell/Divination, Technique/Acrobatics talents in place of Technique/Survival, and Evasion in place of Track.

= 1.0.6 =
- Fixed typo that prevented removal of the "esp" and "sight" properties from items
- Removed Yaldan Baoth from generation

= 1.0.5 =
- Fixed power removal on Eye of the Forest and Fortune's Eye
- Removed Helm of the Dwarven Emperors from generation

= 1.0.4 =
- Removed Track, Arcane Eye, and Earth's Eyes from items
- Fixed possible crash when loading entity files (especially in Infinite Dungeon/Arena)

= 1.0.3 =
- Fixed item property removal

= 1.0.2 =
- "Bite the bullet" and remove light radius from way more items including addon items, at the expense of longer load times.
- Changed Corrupt Light and Shadowmeld to reflect lighting removal
- Removed Darkness entirely from the NPCs that have it (it was already never used, but it was silly to have it show up on the description)
- Removed Invisibility entirely from the NPCs that have it (and random bosses) instead of trying and failing to stop it from starting sustained

= 1.0.1 =
- Remove light radius etc. from a few more items

= 1.0.0 =
- Initial release]]
tags = { 'quicktome' }
data = true
hooks = true
superload = true
overload = true
