local reward = {
	all = {
		["technique/conditioning"] = true,
		["technique/acrobatics"] = true,
	},
	normal = {
		["spell/conveyance"] = true,
		["spell/staff-combat"] = true,
		["spell/stone-alchemy"] = true,
		["celestial/chants"] = true,
		["celestial/light"] = true,
		["chronomancy/chronomancy"] = true,
	},
	antimagic = {
		["wild-gift/call"] = true,
		["wild-gift/mindstar-mastery"] = true,
		["technique/mobility"] = true,
		["technique/field-control"] = true,
		["psionic/dreaming"] = true,
	},
}
local function generate_rewards()
	local answers = {}
	local what = game.player:attr("forbid_arcane") and reward.antimagic or reward.normal
	table.merge(what, reward.all)
	if what then
		for tt, mastery in pairs(what) do if game.player:knowTalentType(tt) == nil then
			local tt_def = game.player:getTalentTypeFrom(tt)
			local cat = tt_def.type:gsub("/.*", "")
			local doit = function(npc, player)
				if player:knowTalentType(tt) == nil then player:setTalentTypeMastery(tt, 0.9) end
				player:learnTalentType(tt, true)
			end
			answers[#answers+1] = {("[%s (at mastery %0.2f)]"):format(cat:capitalize().." / "..tt_def.name:capitalize(), 0.9),
				action=doit,
				on_select=function(npc, player)
					game.tooltip_x, game.tooltip_y = 1, 1
					game:tooltipDisplayAtMap(game.w, game.h, "#GOLD#"..(cat:capitalize().." / "..tt_def.name:capitalize()).."#LAST#\n"..tt_def.description)
				end,
			}
		end end
	end
	return answers
end

newChat{ id="welcome",
	text = [[Learn which category?]],
	answers = generate_rewards(),
}

return "welcome"
