-- t-engine superload. Scary! Good thing the game is already broken.
local _M = loadPrevious(...)

local base_loaded = _M.loaded
function _M:loaded()
	local rval = base_loaded(self)

	-- This is the original __call, except it always returns true for valid squares, and never
	-- unlights squares. Lighting squares is still sort of calculated.
	local qmaplite = function(t, x, y, v)
		if not x or not y or x < 0 or y < 0 or x >= self.w or y >= self.h then return end
		if v then
			t[x + y * self.w] = v
			self._map:setLite(x, y, v)
			self.changed = true
		end
		return true
	end
	-- Pretend everything is lit, always. Nothing bad could ever happen because of that, right?
	-- Our approach to this is kind of bizarre. I'd prefer to simply return true from the __index
	-- metamethod every time; that'd make more sense and be more efficient. Unfortunately, the serialization
	-- code doesn't like that (can't figure out why exactly), and the game will blow up upon trying to save.
	-- So instead we force the entire table to be true at all times after loading. Yuck.
	setmetatable(self.lites, {__newindex = function(t,k,v) rawset(t,k,v or true) end, __call = qmaplite})
	_M.liteAll(self, 0, 0, self.w, self.h)
	return rval
end

return _M
