local _M = loadPrevious(...)

local base_canSeeNoCache = _M.canSeeNoCache

function _M:canSeeNoCache(actor, def, def_pct)
	local rhit, rchance = base_canSeeNoCache(self, actor, def, def_pct)
	if actor and self == game.player and def == nil then
		-- another in our long list of hacks. In this scenario, the actor
		-- would only be unseen if invisible or stealthed...and we want
		-- the player to always see them in that case!
		-- Q: why not just give the player infinite or very large see invisible/stealth?
		-- A: the way checkHitOld works requires that the parameters be in a relatively
		--    specific range in order to always succeed; if the attack exceeds the defense
		--    by TOO much, then it will start to always fail instead, because of getting NaN!
		--    so it's actually safer to do this
		return true, 100
	end
	return rhit, rchance
end

return _M
