local _M = loadPrevious(...)

local base_combatArmor = _M.combatArmor

-- Armour of Shadows gives its bonus everywhere
function _M:combatArmor()
	local rval = base_combatArmor(self)
	if self:knowTalent(self.T_ARMOUR_OF_SHADOWS) and game.level.map.lites(self.x, self.y) then
		return rval + self:callTalent(self.T_ARMOUR_OF_SHADOWS,"ArmourBonus")
	end
	return rval
end

local base_combatArmorHardiness = _M.combatArmorHardiness
function _M:combatArmorHardiness()
	local rval = base_combatArmorHardiness(self)
	if self:knowTalent(self.T_ARMOUR_OF_SHADOWS) and game.level.map.lites(self.x, self.y) then
		return rval+50
	end
	return rval
end

-- Preternatural Senses and Thought Sense defense bonus
local base_combatDefenseBase = _M.combatDefenseBase
function _M:combatDefenseBase(fake)
	local rval = base_combatDefenseBase(self,fake)
	local add = 0
	-- most talent defense bonuses do not respect defense multiplier, so
	-- neither do these.
	if not self:attr("encased_in_ice") then
		if self:knowTalent(self.T_PRETERNATURAL_SENSES) then
			local t = self:getTalentFromId(self.T_PRETERNATURAL_SENSES)
			add = add + t.getDefense(self, t)
		end
		if self:knowTalent(self.T_THOUGHT_SENSE) then
			local t = self:getTalentFromId(self.T_THOUGHT_SENSE)
			add = add + t.getDefense(self, t)
		end
	end
	return math.max(0, rval+add)
end

-- Preternatural Senses crit bonuses
local base_combatMindCrit = _M.combatMindCrit
function _M:combatMindCrit(add)
	local rval = base_combatMindCrit(self,add)
	local add = 0 -- we already added the add parameter in base function
	if self:knowTalent(self.T_PRETERNATURAL_SENSES) then
		local t = self:getTalentFromId(self.T_PRETERNATURAL_SENSES)
		add = add+t.getCriticalChance(self, t)
	end
	return util.bound(rval+add, 0, 100)
end

local base_combatCrit = _M.combatCrit
function _M:combatCrit(weapon)
	local rval = base_combatCrit(self,weapon)
	local add = 0
	if self:knowTalent(self.T_PRETERNATURAL_SENSES) then
		local t = self:getTalentFromId(self.T_PRETERNATURAL_SENSES)
		add = add+t.getCriticalChance(self, t)
	end
	return math.max(0,rval+add)
end

return _M
