local noReqs = function(talent) talent.require.special = nil end
local specialChanges = {
	["T_ARMOUR_OF_SHADOWS"] = noReqs,
	["T_CORRUPTED_SHELL"] = function(talent)
		talent.require.special.desc="Have destroyed Zigur with the Grand Corruptor."
		talent.require.special.fct=function(self)
			return (game.state.birth.ignore_prodigies_special_reqs or (
			self:hasQuest("anti-antimagic") and 
			self:hasQuest("anti-antimagic"):isStatus(engine.Quest.DONE) and
			not self:hasQuest("anti-antimagic"):isStatus(engine.Quest.COMPLETED, "grand-corruptor-treason")
		)) end
	end,
	["T_ENDLESS_WOES"] = noReqs,
	["T_ELEMENTAL_SURGE"] = noReqs,
	["T_WINDBLADE"] = noReqs,
	["T_GIANT_LEAP"] = noReqs,
	["T_ROLL_WITH_IT"] = noReqs,
	["T_VITAL_SHOT"] = noReqs,
	["T_SPECTRAL_SHIELD"] = function(talent)
		talent.require.special.desc="Know the Block talent and have cast at least one spell"
		talent.require.special.fct=function(self) return self:knowTalent(self.T_BLOCK) and self.talent_kind_log and self.talent_kind_log.spell and self.talent_kind_log.spell >= 1 end
	end,
	["T_TEMPORAL_FORM"] = function(talent)
		talent.require.special.desc="Have cast at least one spell and visited a zone outside of time"
		talent.require.special.fct=function(self) return self.talent_kind_log and self.talent_kind_log.spell and self.talent_kind_log.spell >= 1 and (game.state.birth.ignore_prodigies_special_reqs or self:attr("temporal_touched")) end
	end,
	["T_BLIGHTED_SUMMONING"] = function(talent)
		talent.require.special.desc="Have summoned at least one creature affected by this talent"
		talent.require.special.fct=function(self) return self:attr("summoned_times") and self:attr("summoned_times") >= 1 end
	end,
	["T_CAUTERIZE"] = function(talent)
		talent.require.special.desc="Have cast at least one spell"
		talent.require.special.fct=function(self) return self.talent_kind_log and self.talent_kind_log.spell and self.talent_kind_log.spell >= 1 end
	end,
	["T_MASSIVE_BLOW"] = noReqs,
	["T_IRRESISTIBLE_SUN"] = noReqs,
	["T_HIDDEN_RESOURCES"] = noReqs,
	["T_LUCKY_DAY"] = noReqs,
	["T_MENTAL_TYRANNY"] = noReqs,

	["T_AUTOMATED_REFLEX_SYSTEM"] = noReqs,
	["T_ARCANE_AMPLIFICATION_DRONE"] = noReqs,
	["T_PAIN_ENHANCEMENT_SYSTEM"] = noReqs,
	["T_RANGE_AMPLIFICATION_DEVICE"] = noReqs,
}

for talentId,talent in pairs(Talents.talents_def) do
	-- changes for specific talents (just prodigies at the moment)
	if specialChanges[talentId] and type(talent.require) == "table" then specialChanges[talentId](talent) end
end
