long_name = "QuickTome: Remove Stat Requirements"
short_name = "qt-statreq-removal"
for_module = "tome"
version = {1,5,5}
addon_version = {1,0,7}
weight = 216992 -- All QuickTome addons have weight between 216000 and 216999.
author = { "minmay", "a@cowmuffins.net" }
homepage = "http://www.cowmuffins.net/"
description = [[This addon is part of the QuickTome addon set.

This addon removes stat requirements from talents and equipment. Generally, stat requirements are annoying but not meaningful, because you can just juggle +stat equipment. Other requirements such as being a certain level or knowing another talent are NOT removed.
There are approaches other than removal (like using your base stats, or disabling/removing the talents/equipment if your stats fall below the requirements) but those are much further from the status quo than just removing the requirements.

Special prodigy requirements are also adjusted to eliminate grinding or equipment swapping:
- Damage dealt/taken requirements are eliminated entirely.
- Roll With It no longer requires being knocked back.
- Spectral Shield no longer requires a block value over 200.
- Cauterize, Spectral Shield, and Temporal Form only require casting one spell.
- Blighted Summoning only requires summoning one creature.
- Massive Blow no longer requires digging.
- Hidden Resources no longer requires being close to death.
- Lucky Day no longer requires +5 luck.

===== Compatibility =====
This addon is guaranteed to be compatible with the rest of the QuickTome set. If it isn't, that is a bug and should be reported.

This addon superloads the following functions non-destructively:
/engine/Object.lua:getRequirementDesc()
/engine/interface/ActorInventory.lua:canWearObject()
/engine/interface/ActorTalents.lua:canLearnTalent()
/engine/interface/ActorTalents.lua:getTalentReqDesc()

This addon uses the ToME:load hook to overwrite some requirements and requirement descriptions for prodigies.

Weight: 216992

===== Changelog =====

= 1.0.7 =
- Marginally increase compatibility with other addons (fixes Inferno Race Pack)

= 1.0.6 =
- Fix a really stupid mistake

= 1.0.5 =
- Reversed changelog order
- The addon now uses a completely different approach. Essentially, stat requirements are now "ignored" rather than "removed". This greatly improves compatibility with other addons, edge cases like Crown of Burning Pain, and items vault.

= 1.0.4 =
- Updated for ToME4 version 1.4.8
- Removed techniques.lua overload; a different, less intrusive hack is now used to remove stat requirements for techniques

= 1.0.3 =
- Updated for ToME4 version 1.4.0 and 1.4.1

= 1.0.2 =
- Fixed possible crash when loading entities files (especially in Infinite Dungeon and Arena)

= 1.0.1 =
- Removed stat requirement from Crown of Burning Pain

= 1.0.0 =
- Initial release]]
tags = { 'quicktome', 'convenience' }
hooks = true
data = true
superload = true
