local _M = loadPrevious(...)

local base_getRequirementDesc = _M.getRequirementDesc

-- Temporarily remove stat requirement
function _M:getRequirementDesc(who, ...)
	local req = rawget(self, "require")
	local isFunction
	if type(req) == "function" then
		isFunction = req
		req = req(self, t)
	end

	local statReq

	if req and req.stat then
		statReq = req.stat
		req.stat = nil
		-- If the requirement is now empty, toss it entirely
		if not (next(req) or isFunction) then
			self["require"] = nil
		end
	end
	
	if isFunction then
		self["require"] = req
	end
	local rval = base_getRequirementDesc(self, who, ...)
	if isFunction then
		self["require"] = isFunction
	end

	-- Put back the original stat requirement
	if statReq and not isFunction then
		if not self["require"] then
			req = {}
			self["require"] = req
		end
		req.stat = statReq
	end

	return rval
end

return _M
