local _M = loadPrevious(...)

local base_canWearObject = _M.canWearObject

-- Temporarily remove stat requirement
function _M:canWearObject(o, try_slot, ...)
	local req = rawget(o, "require")
	local isFunction
	if type(req) == "function" then
		isFunction = req
		req = req(self, t)
	end

	local statReq

	if req and req.stat then
		statReq = req.stat
		req.stat = nil
		-- If the requirement is now empty, toss it entirely
		if not (next(req) or isFunction) then
			o["require"] = nil
		end
	end
	
	if isFunction then
		o["require"] = req
	end
	local rval,rval2 = base_canWearObject(self, o, try_slot, ...)
	if isFunction then
		o["require"] = isFunction
	end

	-- Put back the original stat requirement
	if statReq and not isFunction then
		if not o["require"] then
			req = {}
			o["require"] = req
		end
		req.stat = statReq
	end

	return rval,rval2
end

return _M
