local _M = loadPrevious(...)

local base_canLearnTalent = _M.canLearnTalent

-- Temporarily remove stat requirement
function _M:canLearnTalent(t, offset, ignore_special, ...)
	local req = rawget(t, "require")
	local isFunction
	if type(req) == "function" then
		isFunction = req
		req = req(self, t)
	end

	local statReq

	if req and req.stat then
		statReq = req.stat
		req.stat = nil
		-- If the requirement is now empty, toss it entirely
		if not (next(req) or isFunction) then
			t["require"] = nil
		end
	end

	if isFunction then
		t["require"] = req
	end
	local rval,rval2 = base_canLearnTalent(self, t, offset, ignore_special, ...)
	if isFunction then
		t["require"] = isFunction
	end

	-- Put back the original stat requirement
	if statReq and not isFunction then
		if not t["require"] then
			req = {}
			t["require"] = req
		end
		req.stat = statReq
	end

	return rval,rval2
end

local base_getTalentReqDesc = _M.getTalentReqDesc

-- Temporarily remove stat requirement
function _M:getTalentReqDesc(t_id, levmod, ...)
	local t = _M.talents_def[t_id]
	local req = t.require
	local isFunction
	if type(req) == "function" then
		isFunction = req
		req = req(self, t)
	end

	local statReq

	if req and req.stat then
		statReq = req.stat
		req.stat = nil
		-- If the requirement is now empty, toss it entirely
		if not (next(req) or isFunction) then
			t["require"] = nil
		end
	end

	if isFunction then
		t["require"] = req
	end
	local rval = base_getTalentReqDesc(self, t_id, levmod, ...)
	if isFunction then
		t["require"] = isFunction
	end

	-- Put back the original stat requirement
	if statReq and not isFunction then
		if not t["require"] then
			req = {}
			t["require"] = req
		end
		req.stat = statReq
	end

	return rval
end

return _M
