long_name = "QuickTome: Zone Overhaul"
short_name = "qt-zone-overhaul"
for_module = "tome"
version = {1,5,5}
addon_version = {1,0,28}
weight = 216063 -- All QuickTome addons have weight between 216000 and 216999.
author = { "minmay", "a@cowmuffins.net" }
homepage = "http://www.cowmuffins.net/"
description = [[This addon is part of the QuickTome addon set.

It's time for QuickTome to begin living up to its name. This addon removes many static and slow zones and levels from the game to make it shorter and quicker, along with many blatant grinding opportunities.
Naturally, this makes the game somewhat harder.
Currently experience gain is increased by 25% in Maj'Eyal (does not affect other campaigns), but available experience should still be lower than without this addon.
To somewhat compensate for the reduced number of items, the quality of items found on the ground and items dropped by bosses is increased: egos, greater egos, double (greater) egos, and artifacts are more common. Material level and level range constraints still apply.

The following zones are no longer accessible:
- The lumberjack village
- Derth, Elvala, and Shatur (The alchemists have moved to Last Hope, Tempest Peak is now revealed from the start)
- Sandworm Lair
- The slavers' compound
- Ruined Dungeon
- Conclave Vault
- Sludgenest
- Noxious Caldera
- Ancient elven ruins (Eternal Night set can now generate anywhere)
- Ruins of Telmur (Staff pieces can now generate anywhere)
- Fearscape (Tannen)
- Unremarkable cave (The farportal now takes you to the east worldmap)
- Ardhungol
- Shadow Crypt
- Briagh's Lair (Resonating Diamond is now found in the Vor Armoury)
- Erúan
- Charred Scar (The final fight is the same as if the player completed it)
- Flooded Cave
- Temple of Creation (Legacy of the Naloren no longer has special requirements and grants the weapon upon learning the prodigy)

The following zones are shortened:
- Abashed Expanse: first level removed.
- Conclave Vault: second and third level removed.
- Daikara: first level removed.
- Dreadfell: first four levels removed.
- Golem Graveyard: no longer contains enemies, events, or items. Atamathon is now the only reason to visit the zone.
- High Peak: first seven levels removed.
- Old Forest: first level removed.
- Ruined Halfling Complex: first level removed.
- Temporal Rift: first two levels removed.
- Trollmire: final level removed (Bill's lair), but Bill is the zone guardian instead of Prox or Shax.

In addition:
- Maj'Eyal zones no longer use the player's level to decide their base level. Instead, they have fixed levels. Online event zones such as Bearscape still use the player's level.
- Only two of the Trollmire, Ruins of Kor'Pul, Norgos' Lair, Heart of the Gloom, Scintillating Caves, and Rhaloren Camp may be entered each game. After entering two, the other four become inaccessible. Also, if you have a racial starting quest that uses these zones, it will be completed automatically (otherwise you could end up with an impossible quest at the top of your quest screen for the rest of the game).
- Gorbat and Grushnak Pride have been merged into Grushbat Pride, which uses Grushnak Pride's layout and level range and contains monsters from both zones.
- Vor and Rak'Shor Pride have been merged into Rak'Vor Pride, which uses Rak'Shor Pride's layout, Vor Pride's level range, and contains monsters from both zones as well as the occasional lich.
- The Spellblaze Crystal, Rhaloren Inquisitor, Withering Thing, and Dreaming One no longer drop specific artifacts (thus there's no reason to go to their zones just because you want crystal focus/eye of the dreaming one/rod of annulment/etc)
- Ruins of Kor'Pul and Rhaloren Camp no longer generate glowing chests.
- Wilderness patrols no longer exist.
- Towns no longer have random NPCs.
- The Heart of the Sandworm Queen is now dropped by the Daikara boss. (This is in addition to that boss' original drops.) This boss is also removed from the Infinite Dungeon (fixme).
- The Brotherhood of Alchemists quest is gone; the Focus and Foundations talent points are rolled into your normal levelups.
- Actor experience value in Maj'Eyal is increased by 25%.
- Item quality is increased somewhat.
- Gold found on the ground and gold received via selling/transmogrification is increased by 50%. The 25 gold cap on transmogrification and the "max buy" caps on shops have been increased to 10000.
- The Transmogrification Chest always uses Extract Gems if available (and it would increase the gold value); you are not required to upgrade it in the fortress.
- The Room of Death in the Vor Armoury no longer offers items, gold, or experience.
- The orc-pride quest and Relentless Pursuit talent are now granted upon entering the Far East, removing the need to talk to Aeryn to get them.
- Backup guardians are removed entirely. Wyrm Bile is removed, but Heart of the Sandworm Queen now grants two levels of drake_touched, and you receive a category point at level 40. Atamathon's Lost Ruby Eye is now in Vor Armoury.
- Traveling to the Far East establishes farportals between Last Hope and Gates of Morning immediately; the related quests are gone.
- The Fungus tree is now granted immediately upon going antimagic, instead of being tied to Urkis.
- Ritches are now found in Mark of the Spellblaze.
- Spiders are now found more often in Reknor.
- Artifacts are no longer restricted by continent.

Yes, this makes it impossible to get some unlocks/achievements and to enter the Infinite Dungeon from the main game.

NOTE: It's recommended that you disable this addon for campaigns other than Maj'Eyal (Infinite Dungeon, Arena, Orcs). This addon IS compatible with Ashes of Urh'Rok and Embers of Rage, but may have strange effects on the Orcs campaign.

===== Compatibility =====
This addon is guaranteed to be compatible with the rest of the QuickTome set. If it isn't, that is a bug and should be reported.

This addon OVERLOADS these files, and will not be compatible with other addons that touch them:
/data/chats/alchemist-derth.lua
/data/chats/alchemist-elvala.lua
/data/chats/alchemist-hermit.lua
/data/chats/alchemist-last-hope.lua
/data/chats/angolwen-staves-store.lua
/data/chats/ardhungol-start.lua
/data/chats/jewelry-store.lua
/data/chats/last-hope-weapon-store.lua
/data/chats/sorcerer-fight.lua
/data/chats/sorcerer-end.lua
/data/chats/temporal-rift-end.lua
/data/chats/zemekkys.lua
/data/chats/zigur-mindstar-store.lua
/data/lore/trollmire.lua
/data/maps/towns/angolwen.tmx
/data/maps/towns/gates-of-morning.lua
/data/maps/towns/irkkk.lua
/data/maps/towns/iron-council.lua
/data/maps/towns/last-hope.lua
/data/maps/towns/point-zero.lua
/data/maps/towns/zigur.lua
/data/maps/zones/vor-armoury-last.lua
/data/quests/antimagic.lua
/data/quests/lightning-overload.lua
/data/quests/orc-pride.lua
/data/quests/pre-charred-scar.lua
/data/quests/starter-zones.lua
/data/quests/west-portal.lua
/data/zones/abashed-expanse/zone.lua
/data/zones/blighted-ruins/zone.lua
/data/zones/crypt-kryl-feijan/zone.lua
/data/zones/daikara/zone.lua
/data/zones/deep-bellow/zone.lua
/data/zones/dreadfell/zone.lua
/data/zones/dreadfell-ambush/zone.lua
/data/zones/golem-graveyard/events.lua
/data/zones/golem-graveyard/zone.lua
/data/zones/grushnak-pride/grids.lua
/data/zones/grushnak-pride/npcs.lua
/data/zones/grushnak-pride/objects.lua
/data/zones/grushnak-pride/zone.lua
/data/zones/halfling-ruins/events.lua
/data/zones/halfling-ruins/zone.lua
/data/zones/heart-gloom/zone.lua
/data/zones/high-peak/zone.lua
/data/zones/keepsake-meadow/zone.lua
/data/zones/lake-nur/zone.lua
/data/zones/mark-spellblaze/npcs.lua
/data/zones/mark-spellblaze/zone.lua
/data/zones/maze/zone.lua
/data/zones/murgol-lair/zone.lua
/data/zones/norgos-lair/zone.lua
/data/zones/old-forest/zone.lua
/data/zones/paradox-plane/zone.lua
/data/zones/rak-shor-pride/events.lua
/data/zones/rak-shor-pride/grids.lua
/data/zones/rak-shor-pride/npcs.lua
/data/zones/rak-shor-pride/objects.lua
/data/zones/rak-shor-pride/zone.lua
/data/zones/reknor/npcs.lua
/data/zones/reknor/zone.lua
/data/zones/reknor-escape/zone.lua
/data/zones/rhaloren-camp/events.lua
/data/zones/rhaloren-camp/zone.lua
/data/zones/ritch-tunnels/zone.lua
/data/zones/ruins-kor-pul/events.lua
/data/zones/ruins-kor-pul/zone.lua
/data/zones/scintillating-caves/zone.lua
/data/zones/shertul-fortress/zone.lua
/data/zones/slazish-fen/zone.lua
/data/zones/slime-tunnels/zone.lua
/data/zones/tempest-peak/zone.lua
/data/zones/temporal-rift/zone.lua
/data/zones/thieves-tunnels/zone.lua
/data/zones/town-angolwen/zone.lua
/data/zones/town-gates-of-morning/zone.lua
/data/zones/town-irkkk/zone.lua
/data/zones/town-iron-council/zone.lua
/data/zones/town-last-hope/traps.lua
/data/zones/town-last-hope/zone.lua
/data/zones/town-point-zero/zone.lua
/data/zones/town-zigur/zone.lua
/data/zones/trollmire/zone.lua
/data/zones/unhallowed-morass/zone.lua
/data/zones/valley-moon/zone.lua
/data/zones/valley-moon-caverns/zone.lua
/data/zones/vor-armoury/zone.lua
/data/zones/wilderness/events.lua

This addon superloads and OVERWRITES these functions:
/mod/class/Actor.lua: transmoInven
/mod/class/Game.lua: loaded
/mod/class/GameState.lua: activateBackupGuardian, defaultEntityFilter, entityFilterAlter, zoneCheckBackupGuardian
(It also adds a function "qt_activateBackupGuardian" and a field "qt_zone_overhaul_version")

This addon superloads these functions, but not destructively:
/mod/class/Actor.lua: expWorth, transmoPricemod, levelup
/mod/class/GameState.lua: goneEast
/mod/class/Store.lua: init, getObjectPrice

Weight: 216063

===== Changelog =====

= 1.0.0 =
- Initial release

= 1.0.1 =
- Fix Sandworm Lair removal (oops)

= 1.0.2 =
- Shorten Temporal Rift
- Add a marker for use by qt-improved-recall (not visible to player)

= 1.0.3 =
- Hotfix for Temporal Rift exit

= 1.0.4 =
- Removed Shadow Crypt.
- Only two of the Trollmire, Ruins of Kor'Pul, Norgos' Lair, Heart of the Gloom, Scintillating Caves, and Rhaloren Camp may be entered each game. After entering two, the other four become inaccessible. The guardians in Heart of the Gloom, Scintillating Caves, and Rhaloren Camp no longer have specific artifacts associated with them (they always give random ones).
- The Trollmire no longer has its final level (Bill's lair), but Bill replaces Prox or Shax.
- Ruins of Kor'Pul and Rhaloren Camp no longer generate glowing chests.
- Actor experience value in Maj-Eyal is slightly increased (+10%).
- Fixed possible crash when loading entity files (especially in Infinite Dungeon/Arena)

= 1.0.5 =
- Actually upload the right version (oops again)

= 1.0.6 =
- *Probably* fix a seemingly random bug that prevents the starter zones quest from updating

= 1.0.7 =
- Actually fix that bug (the culprit was a combination of "restart with the same character", and me being stupid)

= 1.0.8 =
- Fix serialization bug with zone entrance removal (and generally make the code for it less stupid).

= 1.0.9 =
- The backup guardians quest is now granted when a portal to Maj'Eyal is created, instead of when it is used, since users of qt-improved-recall have no need to use the portal directly.
- The west-portal quest, orc-pride quest, and Relentless Pursuit talent are now granted upon entering the Far East, removing the need to talk to Aeryn and Zemekkys to get them.
- The first level has been cut from each of Gorbat, Rak'Shor, and Vor prides, leaving them at 2 levels each. Grushnak Pride is unchanged.
- The first two levels have been cut from Erúan.
- The overpowered greater multi-hued wyrms in the Vor Armoury now give the "normal" amount of experience for their level and rank, instead of triple experience like they do in vanilla. In Zone Overhaul games, players shouldn't be reaching level 50 before they even prides or farportals.

= 1.0.10 =
- The tier 1 zone quest is now correctly updated when the player teleports to level 2 of a zone via the Celestial starting quest.

= 1.0.11 =
- Removed Briagh's Lair and moved the Resonating Diamond to Vor Armoury
- Removed the first 5 levels from High Peak
- Increased experience bonus to +20%
- Improved item quality

= 1.0.12 =
- Removed first level of Abashed Expanse
- Removed second and third levels of Conclave Vault
- Removed first level of Daikara
- Removed first two levels of Grushnak Pride
- Removed first level of Old Forest

= 1.0.13 =
- Removed Erúan and Charred Scar
- Made High Peak and final fight act as if Charred Scar was completed successfully
- Increased most sources of gold by 50%
- Removed shop buy/transmogrification limit
- Update superload list
- Add ritches to Mark of the Spellblaze
- Add spiders to Reknor
- The Transmogrification Chest always uses Extract Gems if available (and it would increase the gold value); you are not required to upgrade it in the fortress.

= 1.0.14 =
- Updated for ToME4 1.4.0

= 1.0.15 =
- Updated for ToME4 1.4.8
- Now compatible with the Automated Portable Extractor from Embers of Rage. (This is only relevant when playing Maj'Eyal characters with an APE; the orcs campaign is not shortened yet and for now you should disable this addon there.)
- Greatly improved campaign detection. Almost no changes are applied to games in non-Maj'Eyal campaigns now.

= 1.0.16 =
- Fixed extremely embarrassing regression that inverted the logic of the transmogrification price cap change.

= 1.0.17 =
- Removed the first four levels of Dreadfell. It now has two backup guardians per level.
- Removed events, items, and NPCs from Golem Graveyard.

= 1.0.18 =
- Merged Rak'shor and Vor Pride into Rak'Vor Pride.
- Merged Grushnak and Gorbat Pride into Grushbat Pride.
- Removed the following backup guardians: Corrupted Sand Wyrm, Nimisil, Snaproot, Spellblaze Simulacrum, The Abomination. The Wyrm Bile, Atamathon's Ruby Eye, Lunar Shield, Crystal Heart, and Petrified Wood have been redistributed to the other backup guardians (in addition to their normal drops).
- Increased experience multiplier from 20% to 25%.
- Completely overhauled item drop weights to be more coherent and consistent. (The only change here that players are likely to notice is that bosses drop uniques more often).

= 1.0.19 =
- Fixed bug that made the wrong item drop tables apply in some situations

= 1.0.20 =
- Fixed possible crash in entityFilterAlter

= 1.0.21 =
- Greatly reduce lesser vault frequency in Grushbat Pride

= 1.0.22 =
- Removed Flooded Cave, Temple of Creation, Derth, Elvala, Shatur, Unremarkable Cave
- Removed shops except for the lost merchant (you can still buy combat/staff/mindstar training and imbue rings)
- Stire and Marus have moved to Last Hope
- Made Tempest Peak revealed from the start
- Joining Zigur now grants Fungus immediately
- Legacy of the Naloren no longer has special requirements; learning Legacy of the Naloren now grants the trident immediately
- Zone base levels no longer depend on the player's level

= 1.0.23 =
- Updated for ToME4 version 1.5.1

= 1.0.24 =
- Removed an unused superload
- Nerfed fixed levels on Nightmare and Insane a bit. Tier 2 zones were being fixed at level 24 on Insane, compared to ranges of 11.5-25 in vanilla. (Vanilla Madness is lower than that!) Coupled with the loss of shops, villager experience, and most tier 1 zones, Insane was nearly impossible. The zone level multiplier has been reduced from 1.5 to 1.35 and the extra constant added levels have been changed to the 1.5.5 ones. This will still result in higher zone levels than in vanilla in almost all cases - along with all the other difficulty increases. Madness is unchanged.
- Added randbosses to Normal and Nightmare to make those difficulty levels a bit more challenging.

= 1.0.25 =
- Shortened High Peak further, from 5 to 3 levels.
- Shortened Ruined Halfling Complex slightly, removing the first level.
- Removed the extra loot from the Room of Death and made the wyrms no longer give experience.

= 1.0.26 =
- Fixed Ruined Halfling Complex not having an exit to the wilderness

= 1.0.27 =
- Removed Ancient Elven Ruins
- Removed Conclave Vault
- Towns no longer have random NPCs at all
- Bindings/Crown of Eternal Night can now generate anywhere
- Brotherhood of Alchemists quest is gone. The extra talent points from Elixir of Focus and Foundations are given at levels 5, 7, 10, and 12.
- Traveling east establishes a farportal in both towns immediately; no more There/Back and Back/There Again quests. Zemekkys' door is gone.
- Removed backup guardians. You get a category point at level 40 to make up for the loss of Wyrm Bile.
- Removed Tannen and the corresponding zones (Telos' Bottom Half can now generate anywhere)
- Removed Melnela
- World/boss artifacts are no longer restricted by continent
- Nerfed vault items but slightly increased floor unique drops

= 1.0.28 =
- Reduced Maze zone level from 14 to 10
- Reduced Old Forest zone level from 14 to 12
- Added a quest with information about Zone Overhaul and available zones
- Made starting quest more likely to successfully be given on weird premade characters etc
- Fixed Agrimley appearing in the wilderness despite his quest being gone]]
tags = { 'quicktome' }
data = true
hooks = true
superload = true
overload = true
