-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009 - 2016 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

quickEntity('@', {show_tooltip=true, name="Statue of King Tolak the Fair", display='@', image="terrain/grass.png", add_displays = {mod.class.Grid.new{image="terrain/statues/statue_tolak.png", z=18, display_y=-1, display_h=2}}, color=colors.LIGHT_BLUE, block_move=function(self, x, y, e, act, couldpass) if e and e.player and act then game.party:learnLore("last-hope-tolak-statue") end return true end})
quickEntity('Z', {show_tooltip=true, name="Statue of King Toknor the Brave", display='@', image="terrain/grass.png", add_displays = {mod.class.Grid.new{image="terrain/statues/statue_toknor.png", z=18, display_y=-1, display_h=2}}, color=colors.LIGHT_BLUE, block_move=function(self, x, y, e, act, couldpass) if e and e.player and act then game.party:learnLore("last-hope-toknor-statue") end return true end})
quickEntity('Y', {show_tooltip=true, name="Statue of Queen Mirvenia the Inspirer", display='@', image="terrain/grass.png", add_displays = {mod.class.Grid.new{image="terrain/statues/statue_mirvenia.png", z=18, display_y=-1, display_h=2}}, color=colors.LIGHT_BLUE, block_move=function(self, x, y, e, act, couldpass) if e and e.player and act then game.party:learnLore("last-hope-mirvenia-statue") end return true end})
quickEntity('X', {show_tooltip=true, name="Declaration of the Unification of the Allied Kingdoms", display='@', image="terrain/grass.png", add_displays = {mod.class.Grid.new{image="terrain/statues/monument_allied_kingdoms.png", z=18, display_y=-1, display_h=2}}, color=colors.LIGHT_BLUE, block_move=function(self, x, y, e, act, couldpass) if e and e.player and act then game.party:learnLore("last-hope-allied-kingdoms-foundation") end return true end})

-- defineTile section
defineTile("<", "GRASS_UP_WILDERNESS")
defineTile("#", "HARDWALL")
defineTile("&", "HARDMOUNTAIN_WALL")
defineTile("~", "DEEP_WATER")
defineTile("_", "FLOOR_ROAD_STONE")
defineTile("-", "GRASS_ROAD_STONE")
defineTile(".", "GRASS")
defineTile("t", "TREE")
defineTile(" ", "FLOOR")

-- only for combat training and shoot talent
defineTile('A', "HARDWALL", nil, nil, "ARCHER_WEAPON_STORE")

defineTile('E', "HARDWALL", nil, nil, "ELDER")
defineTile('M', "HARDWALL", nil, nil, "RARE_GOODS")
defineTile('F', "HARDWALL", nil, nil, "MELINDA_FATHER")


startx = 25
starty = 0
endx = 25
endy = 0

-- addSpot section
addSpot({6, 20}, "pop-quest", "farportal")
addSpot({7, 19}, "pop-quest", "farportal-player")
addSpot({10, 19}, "pop-quest", "tannen-remove")
addSpot({6, 19}, "pop-quest", "farportal-npc")

-- addZone section

-- ASCII map section
return [[
ttttttttttttttttttttttttt<tttttttttttttttttttttttt
ttttttttttttttttttttt~~~X-X~~~tttttttttttttttttttt
ttttttttttttttttt~~~~~~~.-.~~~~~~~tttttttttttttttt
ttttttttttttttt~~~~~~~~~.-.~~~~~~~~~tttttttttttttt
ttttttttttttt~~~~~~~~####.####~~~~~~~~tttttttttttt
tttttttttttt~~~~~~####_______####~~~~~~ttttttttttt
tttttttttt~~~~~~###   _     _   ###~~~~~~ttttttttt
ttttttttt~~~~~###     _ ### _     ###~~~~~tttttttt
tttttttt~~~~~##       _ ### _       ##~~~~~ttttttt
ttttttt~~~~###      ___ ### ___      ###~~~~tttttt
tttttt~~~~##       __   ###   __       ##~~~~ttttt
tttttt~~~##    #  __  #######  __       ##~~~ttttt
ttttt~~~~#    ### _  ##A# ####  _  #     #~~~~tttt
tttt~~~~##   #### _ ###     ### _ ###    ##~~~~ttt
tttt~~~##   ###   _ #         # _ M###    ##~~~ttt
ttt~~~~#     ##   _  _________  _   ###    #~~~~tt
ttt~~~##          ____~~~_~~~____   ##     ##~~~tt
tt~~~~#  ###      __~~~##.##~~~__           #~~~~t
tt~~~##  ###     __~~###@.t###~~__          ##~~~t
tt~~~#   ###    __~~##ttY-Ztt##~~__          #~~~t
tt~~~#       ## _~~##tt-----tt##~~_ ##       #~~~t
t~~~##      ## __~##t---&-&---t##~__ ##      ##~~~
t~~~#      ### _~~#tt-&&&-&&&-tt#~~_ ###      #~~~
t~~~#      ##  _~##t--&&---&&--t##~_  ##      #~~~
t~~~#  ######  _~#tt-&&-###-&&-tt#~_  ######  #~~~
t~~~#  #####   _~#tt-&&-#E#-&&-tt#~_   #####  #~~~
t~~~#  ######  _~#tt-&&-----&&-tt#~_  ######  #~~~
t~~~#      ##  _~##t--&&---&&--t##~_  ##      #~~~
t~~~#      ### _~~#tt-&&&&&&&-tt#~~_ ###      #~~~
t~~~##      ## __~##t---&&&---t##~__ ##      ##~~~
tt~~~#       ## _~~##tt-----tt##~~_ ##       #~~~t
tt~~~#          __~~##ttttttt##~~__          #~~~t
tt~~~##          __~~###ttt###~~__          ##~~~t
tt~~~~#           __~~~#####~~~__           #~~~~t
ttt~~~##           ___~~~~~~~___     ##    ##~~~tt
ttt~~~~#     ##      _________       ###   #~~~~tt
tttt~~~##   ###     #         #    ####   ##~~~ttt
tttt~~~~##   ####   ###     ###    ###   ##~~~~ttt
ttttt~~~~#    ###    #### ####      #    #~~~~tttt
tttttt~~~##    #      #######           ##~~~ttttt
tttttt~~~~##            ###            ##~~~~ttttt
ttttttt~~~~###          ###          ###~~~~tttttt
tttttttt~~~~~##         ###         ##~~~~~ttttttt
ttttttttt~~~~~###       #F#       ###~~~~~tttttttt
tttttttttt~~~~~~###             ###~~~~~~ttttttttt
tttttttttttt~~~~~~####       ####~~~~~~ttttttttttt
ttttttttttttt~~~~~~~~#########~~~~~~~~tttttttttttt
ttttttttttttttt~~~~~~~~~~~~~~~~~~~~~tttttttttttttt
ttttttttttttttttt~~~~~~~~~~~~~~~~~tttttttttttttttt
ttttttttttttttttttttt~~~~~~~~~tttttttttttttttttttt]]
