return {
	name = "Grushbat Pride",
	display_name = function()
		if game.level.level % 2 == 0 then return "Grushbat Pride ("..(game.level.level/2)..")"
		else return "Grushbat Pride (guarded barracks)"
		end
	end,
	variable_zone_name = true,
	level_range = {45, 45},
	level_scheme = "player",
	max_level = 6,
	decay = {300, 800},
	-- 6 levels but really only 3, the 3 others are just transitions
	actor_adjust_level = function(zone, level, e) return zone.base_level + e:getRankLevelAdjust() + math.floor(level.level / 2) + rng.range(-1,2) end,
	level_adjust_level = function(zone, level) return zone.base_level + math.floor(level.level / 2) end,
	width = 50, height = 50,
	persistent = "zone",
--	all_remembered = true,
--	all_lited = true,
	ambient_music = "Thrall's Theme.ogg",
	min_material_level = 4,
	max_material_level = 5,
	effects = {"EFF_ZONE_AURA_GRUSHNAK","EFF_ZONE_AURA_GORBAT"},
	generator =  {
		map = {
			class = "engine.generator.map.Roomer",
			pride = "grushnak",
			nb_rooms = 10,
			lite_room_chance = 20,
			required_rooms = {"greater_vault"},
			rooms = {"forest_clearing", {"pit",4}, {"greater_vault",2}},
			rooms_config = {pit={filters={{subtype="orc"},{subtype="troll"}}}},
			['.'] = "UNDERGROUND_FLOOR",
			['#'] = "UNDERGROUND_TREE",
			up = "UNDERGROUND_LADDER_UP",
			down = "UNDERGROUND_LADDER_DOWN",
			door = "UNDERGROUND_FLOOR",
			['+'] = "UNDERGROUND_FLOOR",
		},
		actor = {
			class = "mod.class.generator.actor.Random",
			nb_npc = {20, 30},
			guardian = "GRUSHNAK",
		},
		object = {
			class = "engine.generator.object.Random",
			nb_object = {3, 6},
		},
	},
	post_process = function(level, zone)
		if level.level >= 2 and level.level <= 6 then
			game:placeRandomLoreObject("GARKUL_HISTORY"..(level.level-1))
		end
		if level.level == 6 then -- place second guardian, using similar code to the code t-engine uses to place first guardian
			local m = zone:makeEntityByName(level, "actor", "GORBAT")
			if m then
				local x, y = rng.range(0, level.map.w - 1), rng.range(0, level.map.h - 1)
				local tries = 0
				while not m:canMove(x, y) and tries < 1000 do
					x, y = rng.range(0, level.map.w - 1), rng.range(0, level.map.h - 1)
					tries = tries + 1
				end
				zone:addEntity(level, m, "actor", x, y)
			else
				level.force_recreate = true
			end
		end

		for uid, e in pairs(level.entities) do e.faction = e.hard_faction or "orc-pride" end
	end,
	levels =
	{
		[1] = { generator = {
			map = { class = "engine.generator.map.Static", map = "zones/prides-middle" },
			actor = { nb_npc = {0, 0} },
			object = { nb_object = {0, 0} },
		}},
		[2] = { generator = {
			map = { static_replace_tiles = {
					FLOOR = "UNDERGROUND_FLOOR",
					DOOR = "UNDERGROUND_FLOOR",
					WALL = "UNDERGROUND_TREE",
					HARDWALL = "UNDERGROUND_HARDTREE",
					DOOR_VAULT = "UNDERGROUND_VAULT",
			}, },
		}},
		[3] = { generator = {
			map = { class = "engine.generator.map.Static", map = "zones/prides-middle" },
			actor = { nb_npc = {0, 0} },
			object = { nb_object = {0, 0} },
		}},
		[4] = { generator = {
			map = { static_replace_tiles = {
					FLOOR = "UNDERGROUND_FLOOR",
					DOOR = "UNDERGROUND_FLOOR",
					WALL = "UNDERGROUND_TREE",
					HARDWALL = "UNDERGROUND_HARDTREE",
					DOOR_VAULT = "UNDERGROUND_VAULT",
			}, },
		}},
		[5] = { generator = {
			map = { class = "engine.generator.map.Static", map = "zones/prides-middle" },
			actor = { nb_npc = {0, 0} },
			object = { nb_object = {0, 0} },
		}},
		[6] = {
			generator = { map = {
				static_replace_tiles = {
					FLOOR = "UNDERGROUND_FLOOR",
					DOOR = "UNDERGROUND_FLOOR",
					WALL = "UNDERGROUND_TREE",
					HARDWALL = "UNDERGROUND_HARDTREE",
					DOOR_VAULT = "UNDERGROUND_VAULT",
				},
				['.'] = {
					"UNDERGROUND_FLOOR",
					"UNDERGROUND_FLOOR",
					"UNDERGROUND_FLOOR",
					"UNDERGROUND_FLOOR",
					"UNDERGROUND_FLOOR",
					"UNDERGROUND_FLOOR",
					"UNDERGROUND_FLOOR",
					"UNDERGROUND_CREEP",
				},
				down = "SLIME_TUNNELS",
				force_last_stair = true,
			}, },
		},
	},
}
