return {
	name = "High Peak",
	display_name = function(x, y)
		if game.level.level == 11 then return "High Peak: The Sanctum" end
		return "High Peak ("..game.level.level..")"
	end,
	level_range = {60, 60},
	level_scheme = "player",
	max_level = 3,
	decay = {300, 800},
	actor_adjust_level = function(zone, level, e) return zone.base_level + e:getRankLevelAdjust() + level.level-1 + rng.range(-1,2) end,
	width = 50, height = 75,
--	all_remembered = true,
--	all_lited = true,
	persistent = "zone",
	no_worldport = true,
	ambient_music = "Through the Dark Portal.ogg",
	min_material_level = 5,
	max_material_level = 5,
	generator =  {
		map = {
			class = "engine.generator.map.Roomer",
			nb_rooms = 10,
			rooms = {"random_room", {"pit",3}, {"lesser_vault",2}, {"greater_vault",3}},
			rooms_config = {pit={filters={{type="humanoid", subtype="orc"}, {type="humanoid", subtype="naga"}, {type="dragon"}, {type="demon"}}}},
			lesser_vaults_list = {"circle"},
			lite_room_chance = 10,
			['+'] = "DOOR",
			['.'] = "FLOOR",
			['#'] = "WALL",
			up = "FLOOR",
			down = "HIGH_PEAK_UP",
			door = "DOOR",
		},
		actor = {
			class = "mod.class.generator.actor.RandomStairGuard",
			guard = {
				{special_rarity="humanoid_random_boss", random_boss={rank = 3.5, loot_quantity = 2,}},
				{type="demon", subtype="major", random_boss={rank = 3.5, loot_quantity = 2,}},
				{type="humanoid", subtype="naga", random_boss={rank = 3.5, loot_quantity = 2,}},
				{type="humanoid", subtype="orc", random_boss={rank = 3.5, loot_quantity = 2,}},
				{type="undead", subtype="giant", random_boss={rank = 3.5, loot_quantity = 2,}},
				{type="horror", random_boss={rank = 3.5, loot_quantity = 2,}},
			},
			nb_npc = {20, 30},
		},
		object = {
			class = "engine.generator.object.Random",
			nb_object = {6, 9},
		},
		trap = {
			class = "engine.generator.trap.Random",
			nb_trap = {0, 0},
		},
	},
	post_process = function(level)
		game.player:grantQuest("high-peak")
		for uid, e in pairs(level.entities) do e.faction = e.hard_faction or "sorcerers" end
		if level.level == 1 then game:placeRandomLoreObject("ARGONIEL_DIAMOND") end
		if level.level == 2 then game:placeRandomLoreObject("ELANDAR_JOURNAL1") end

		if level.level <= 3 then
			local p = game.player
			local effid = rng.table{
				p.EFF_ZONE_AURA_FIRE, p.EFF_ZONE_AURA_COLD, p.EFF_ZONE_AURA_LIGHTNING, p.EFF_ZONE_AURA_ACID,
				p.EFF_ZONE_AURA_DARKNESS, p.EFF_ZONE_AURA_MIND, p.EFF_ZONE_AURA_LIGHT, p.EFF_ZONE_AURA_ARCANE,
				p.EFF_ZONE_AURA_TEMPORAL, p.EFF_ZONE_AURA_PHYSICAL, p.EFF_ZONE_AURA_BLIGHT, p.EFF_ZONE_AURA_NATURE,
			}
			level.data.effects = {effid}
		end
	end,
	on_turn = function(self)
		if not game.level.allow_portals then return end
		require("mod.class.generator.actor.HighPeakFinal").new(self, game.level.map, game.level, {}):tick()
	end,
	levels =
	{
		[3] = {
			generator = {
				map = {
					down = "PORTAL_BOSS",
					force_last_stair = true,
				}
			}
		},
		[11] = {
			generator = {
				map = {
					class = "engine.generator.map.Static",
					map = "zones/high-peak-last",
				},
				actor = {
					class = "mod.class.generator.actor.Random",
					nb_npc = {0, 0},
				},
				trap = {
					class = "engine.generator.trap.Random",
					nb_trap = {0, 0},
				},
			},
		},
	},
}
