return {
	name = "Rak'Vor Pride",
	level_range = {45, 45},
	level_scheme = "player",
	max_level = 3,
	decay = {300, 800},
	actor_adjust_level = function(zone, level, e) return zone.base_level + e:getRankLevelAdjust() + level.level-1 + rng.range(-1,2) end,
	width = 50, height = 50,
	persistent = "zone",
--	all_remembered = true,
	all_lited = true,
	day_night = true,
	ambient_music = {"March.ogg", "weather/desert_base.ogg"},
	min_material_level = 4,
	max_material_level = 5,
	effects = {"EFF_ZONE_AURA_RAKSHOR","EFF_ZONE_AURA_VOR"},
	generator =  {
		map = {
			class = "engine.generator.map.Roomer",
			nb_rooms = 10,
			['.'] = "BONEFLOOR",
			['#'] = "BONEWALL",
			up = "BONE_LADDER_UP",
			down = "BONE_LADDER_DOWN",
			door = "BONE_DOOR",
			static_replace_tiles = {
				FLOOR = "BONEFLOOR",
				DOOR = "BONE_DOOR",
				WALL = "BONEWALL",
				HARDWALL = "HARDBONEWALL",
				DOOR_VAULT = "BONE_VAULT_DOOR",
			},
			required_rooms = {"greater_vault"},
			rooms = {{"forest_clearing",2}, "random_room", {"lesser_vault",2}, {"greater_vault",4}},
			lesser_vaults_list = {"orc-armoury", "double-t", "crypt", "hostel", "horror-chamber"},
			lite_room_chance = 100,
		},
		actor = {
			class = "mod.class.generator.actor.Random",
			nb_npc = {20, 30},
			guardian = "RAK_SHOR",
		},
		object = {
			class = "engine.generator.object.Random",
			nb_object = {3, 6},
		},
	},
	post_process = function(level, zone)
		for uid, e in pairs(level.entities) do e.faction = e.hard_faction or "orc-pride" end

		game.state:makeAmbientSounds(level, {
			desert1={ chance=250, volume_mod=0.6, pitch=0.6, random_pos={rad=10}, files={"ambient/desert/desert1","ambient/desert/desert2","ambient/desert/desert3"}},
			desert2={ chance=250, volume_mod=1, pitch=1, random_pos={rad=10}, files={"ambient/desert/desert1","ambient/desert/desert2","ambient/desert/desert3"}},
			desert3={ chance=250, volume_mod=1.6, pitch=1.4, random_pos={rad=10}, files={"ambient/desert/desert1","ambient/desert/desert2","ambient/desert/desert3"}},
		})

		if level.level == 3 then -- place second guardian, using similar code to the code t-engine uses to place first guardian
			local m = zone:makeEntityByName(level, "actor", "VOR")
			if m then
				local x, y = rng.range(0, level.map.w - 1), rng.range(0, level.map.h - 1)
				local tries = 0
				while not m:canMove(x, y) and tries < 1000 do
					x, y = rng.range(0, level.map.w - 1), rng.range(0, level.map.h - 1)
					tries = tries + 1
				end
				zone:addEntity(level, m, "actor", x, y)
			else
				level.force_recreate = true
			end
		end
	end,
	levels =
	{
		[1] = {
			width = 64, height = 64,
			generator = { map = {
				class = "engine.generator.map.Static",
				map = "zones/prides",
				up = "BONE_UP_WILDERNESS",
				down = "BONE_LADDER_DOWN",
				floor = "BONEFLOOR",
				wall = "HARDBONEWALL",
				generic_leveler = "BONE_GENERIC_LEVER",
				generic_leveler_door = "BONE_GENERIC_LEVER_DOOR",
				sublevel = {
					class = "engine.generator.map.Town",
					pride = "rak-shor",
					building_chance = 70,
					max_building_w = 8, max_building_h = 8,
					edge_entrances = {6,4},
					floor = "BONEFLOOR",
					external_floor = "BONEFLOOR",
					wall = "BONEWALL",
					up = "BONEFLOOR",
					down = "BONEFLOOR",
					door = "BONE_DOOR",

					static_replace_tiles = {
						FLOOR = "BONEFLOOR",
						DOOR = "BONE_DOOR",
						WALL = "BONEWALL",
						HARDWALL = "HARDBONEWALL",
						DOOR_VAULT = "BONE_VAULT_DOOR",
					},
					nb_rooms = {1,1,2,3},
					rooms = {"lesser_vault", "greater_vault"},
					lesser_vaults_list = {"orc-armoury", "double-t", "crypt", "hostel", "horror-chamber"},
					lite_room_chance = 100,
				},
			}, },
		},
		[3] = {
			generator = { map = {
				down = "BONE_UP_WILDERNESS",
			}, },
		},
	},
}
