local _M = loadPrevious(...)

local orig_worthExp = _M.worthExp
function _M:worthExp(target)
	local rval = orig_worthExp(self,target)
	if game:isCampaign("Maj'Eyal") then
		rval = rval * 1.25
	end
	return rval
end

local origLevelup = _M.levelup

-- Add Focus/Foundations points
function _M:levelup()
	local rval = origLevelup(self)
	if self.player and self.descriptor.world == "Maj'Eyal" then
		if self.level == 5 or self.level == 15 then self.unused_generics = self.unused_generics+1 end
		if self.level == 7 or self.level == 12 then self.unused_talents = self.unused_talents+1 end
		if self.level == 40 then self.unused_talents_types = self.unused_talents_types+1 end
	end
	return rval
end

-- increase item value by 50%
local orig_transmoPricemod = _M.transmoPricemod
function _M:transmoPricemod(o) return orig_transmoPricemod(self,o)*(game:isCampaign("Maj'Eyal") and 1.5 or 1) end

-- overwrite because that's the only way to change the price...this is shit
local orig_transmoInven = _M.transmoInven
function _M:transmoInven(inven, idx, o, transmo_source)
	if not game:isCampaign("Maj'Eyal") then return orig_transmoInven(self,inven,idx,o,transmo_source) end

	transmo_source = transmo_source or self.default_transmo_source
	if (not transmo_source and not self:attr("has_transmo_orcs")) or (transmo_source and transmo_source.define_as ~= "APE") then
		local price = 0 
		o:forAllStack(function(so) price = price + math.min(so:getPrice() * self:transmoPricemod(so), 10000) end)  -- handle stacked objects individually
		price = math.floor(price * 100) / 100 -- Make sure we get at most 2 digit precision
		if price ~= price or not tostring(price):find("^[0-9]") then price = 1 end -- NaN is the only value that does not equals itself, this is the way to check it since we do not have a math.isnan method
		if inven and idx then self:removeObject(inven, idx, true) end

		if self:knowTalent(self.T_EXTRACT_GEMS) and self:callTalent(self.T_EXTRACT_GEMS, "filterGem", o) then
			local gem = self:callTalent(self.T_EXTRACT_GEMS, "getGem", o)

			if gem then
				local gprice = math.min(gem:getPrice() * self:transmoPricemod(gem), 10000) * gem:getNumber()
				gprice = math.floor(gprice * 100) / 100 -- Make sure we get at most 2 digit precision
				if gprice ~= gprice or not tostring(gprice):find("^[0-9]") then gprice = 1 end -- NaN is the only value that does not equals itself, this is the way to check it since we do not have a math.isnan method

				if gprice > price then
					price = gprice
					game.logPlayer(self, "You extract %s from %s", gem:getName{do_color=true, do_count=true}, o:getName{do_color=true, do_count=true})
					o = gem
				end
			end
		end

		self:sortInven()
		self:incMoney(price)
		if self.hasQuest and self:hasQuest("shertul-fortress") and self:isQuestStatus("shertul-fortress", engine.Quest.COMPLETED, "transmo-chest") then self:hasQuest("shertul-fortress"):gain_energy(price/10) end
		game.log("You gain %0.2f gold from the transmogrification of %s.", price, o:getName{do_count=true, do_color=true})
	else
		local price = math.min(o:getPrice() * self:transmoPricemod(o), 10000) * o:getNumber()
		price = math.floor(price * 100) / 100 -- Make sure we get at most 2 digit precision
		if price ~= price or not tostring(price):find("^[0-9]") then price = 1 end -- NaN is the only value that does not equals itself, this is the way to check it since we do not have a math.isnan method
		if inven and idx then self:removeObject(inven, idx, true) end

		if o.metallic and o.material_level then
			local id = "LUMP_ORE"..o.material_level
			if game.party.__ingredients_def[id] then
				game.party:collectIngredient(id, o:getNumber())
			end
		elseif o.type == "scroll" and o.subtype == "infusion" and o.material_level_gen_range then
			local lvl = util.bound(rng.range(o.material_level_gen_range.min, o.material_level_gen_range.max), 1, 5)
			local id = "HERBS"..lvl
			if game.party.__ingredients_def[id] then
				game.party:collectIngredient(id, o:getNumber() * 5)
			end
		elseif o.type == "scroll" and o.subtype == "schematic" and o.material_level_gen_range then
			local lvl = util.bound(rng.range(o.material_level_gen_range.min, o.material_level_gen_range.max), 1, 5)
			local id = "HERBS"..lvl
			if game.party.__ingredients_def[id] then
				game.party:collectIngredient(id, o:getNumber() * 2)
			end
		elseif o.type == "weapon" and o.subtype == "mindstar" and o.material_level then
			local id = "HERBS"..o.material_level
			if game.party.__ingredients_def[id] then
				game.party:collectIngredient(id, o:getNumber())
			end
		end

		self:sortInven()
		self:incMoney(price)
		game.log("You gain %0.2f gold from the melting of %s.", price, o:getName{do_count=true, do_color=true})
	end
end

return _M
